
/***************************************************************************
 *   Copyright (C) 2007 by Alessio 'isazi' Sclocco                         *
 *   isazi@olografix.org                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>

void error(const char *);
int htoi(const char *);

int main(int argc, char *argv[])
{
/* Only a counter */
int i;
/* Hex digits */
char *h, *x;

if ( argc != 3 )
{
	error(argv[0]);
	return -1;
}

switch ( argv[1][1] )
{
	case 'a':
		for ( i = 0; i < strlen(argv[2]); i++ )
		{
			printf("%0.2X", argv[2][i]);
		}
		printf("\n");
		break;
	
	case 'h':
		for ( i = 0; i < strlen(argv[2]); i++ )
		{
			h[0] = argv[2][i];
			x[0] = argv[2][++i];
			if ( isxdigit(h[0]) && isxdigit(x[0]) )
			{
				printf("%c", (16 * htoi(h)) + htoi(x));
			}
		}
		printf("\n");
		break;
	
	default :
		error(argv[0]);
		return -1;
}

return 0;
}

void error(const char *executable)
{
fprintf(stderr, "No WAY!\nMust use ascii2hex in that manner: %s <direction> <string>\n", executable);
fprintf(stderr, "Where direction is:\n");
fprintf(stderr, "\t-a for converting a string from ascii to hexadecimal;\n");
fprintf(stderr, "\t-h for converting a string from hexadecimal to ascii.\n");
}

int htoi(const char *digit)
{
if ( (digit[0] >= '0') && (digit[0] <= '9') )
{
	return atoi(digit);
}
else
{
	switch ( digit[0] )
	{
		case 'a':
		case 'A':
			return 10;
		case 'b':
		case 'B':
			return 11;
		case 'c':
		case 'C':
			return 12;
		case 'd':
		case 'D':
			return 13;
		case 'e':
		case 'E':
			return 14;
		case 'f':
		case 'F':
			return 15;
	}
}
}
